import os
import sys

from pydbus import SystemBus
from gi.repository import GLib

loop = GLib.MainLoop()

class StarterObject(object):
    dbus = '''
    <node>
        <interface name='org.redoswelcome.pydbus.Starter'>
            <method name='start'/>  
            <method name='stop'/>
            <method name='quit'/>
        </interface>
    </node>
    '''
    def start(self):
        os.system("systemctl start redoswelcome-dbus.service")

    def stop(self):
        os.system("systemctl stop redoswelcome-dbus.service")

    def quit(self):
        loop.quit()

if __name__ == "__main__":
    if len(sys.argv) == 1:
        with SystemBus() as bus:
            with bus.publish("org.redoswelcome.pydbus.Starter", StarterObject()):
                loop.run()
    elif len(sys.argv) > 1:
        if sys.argv[1] == "--start":
            with SystemBus() as bus:
                with bus.publish("org.redoswelcome.pydbus.Starter", StarterObject()):
                    loop.run()
        elif sys.argv[1] == "--stop":
            loop.quit()